Unit VgaModeX;
{$R-}

Interface

 Const
  Mcga   = $13;
  Text25 = 3;

 Var
  Screen_Width  : Word;
  Screen_Width2 : Byte;
  Screen_Height : Word;
  MaxSize       : Word;
  Page          : Word;
  PageOfs       : Array[0..3] of Word;
  YOfs          : Array[0..399] of Word;

 Type
  TBuffer       = Array[0..0] of Byte;
  PBuffer       = ^TBuffer;

 {ASM} Procedure Word_Out(Port : Word; Register, Value : Byte);
 {PAS} Procedure ModeX(Width, Height : Word);
 {BTH} Procedure Fill(Color : Byte);
 {ASM} Procedure VideoMode(Mode : Byte);
 {BTH} Procedure Point(X,Y, Col : LongInt);
 {ASM} Procedure VideoTop(S : Word);
 {ASM} Procedure SetDrawPage(P : Byte);
 {ASM} Procedure SelectFrame(B : Byte);
 {ASM} Procedure SetVisualPage(P : Byte);
 {ASM} Procedure Box(X1,Y1, X2, Y2 : Word; Color, Control : Byte);
       Procedure Blit_String(X, Y : Word;Const Text : String; Color : Byte; Trans_Flag : Boolean);


 Type  TSpriteHeader = Record
                         X_Size : Word;
                         Y_Size : Word;
                         Cells  : Byte;
                       End;

 Type  TSprite = Object
                 {-------------------------------}
                  Head    : TSpriteHeader;
                 {-------------------------------}
                  XPos    : LongInt;
                  Current : Word;
                  YPos    : LongInt;
                 {-------------------------------}
                  XSch, YSch : LongInt;
                  XSch2, YSch2 : LongInt;
                  Width, Height : LongInt;
                  Show    : Boolean;
                  Y1,Y2   : Word;
                  X1,X2   : Word;
                 {-------------------------------}
                  Cell   : Array[1..25] of PBuffer;
                 {-------------------------------}
                  Procedure Load(FileName : String; Sprite : Word);
                  Procedure GotoXY(X, Y : LongInt);
                  Procedure Draw;
                  Procedure DrawSolid;
                 End;

 Type  TCreateLib = Object
                    {---------------------------------}
                    F    : File;
                    Head : TSpriteHeader;
                    {---------------------------------}
                    Procedure Open(FileName : String; X, Y, Cells : Word);
                    Procedure AddCell(X,Y : Word);
                    Procedure Close;
                    End;

Implementation

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Select(X : Word);
 Var Calc : Byte;
 Begin
  Asm MOV DX, $03C4; MOV AL, 02; OUT DX, AL; End;
  Calc := 1 SHL (X AND 3);
  Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure TCreateLib.Open;
 Begin
  {$I-}
   Assign(F, FileName);
   Reset(F,1);
  {$I+}
  If IoResult <> 0 Then Begin
    Rewrite(F,1);
  End;
  Seek(F, FileSize(F));
  Head.X_Size := X;
  Head.Y_Size := Y;
  Head.Cells  := Cells;
  BlockWrite(F, Head, SizeOf(Head));
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure TCreateLib.AddCell;
 Var Frame   : Byte;
     XTeller : Word;
     YTeller : Word;
     Width   : Word;
     Height  : Word;
     Buffer  : PBuffer;
     BufPos  : Word;
 Begin

  GetMem(Buffer, Head.X_Size * Head.Y_Size);

  Width  := X + Head.X_Size;
  Height := Y + Head.Y_Size;

  BufPos := 0;

  For Frame := 0 To 3 Do Begin
    For YTeller := Y To Height Do Begin
    Word_Out($03C4,$02, (1 Shl Frame));
    Word_Out($03C5,$02, (1 Shl Frame));
      For XTeller := (X SHR 2) To (WIDTH SHR 2) Do Begin
        Buffer^[BufPos] := Mem[$A000: YOfs[YTeller] + XTeller + Page];
        Inc(BufPos);
      End;
    End;
  End;

  BlockWrite(F, Buffer^, Head.X_Size * Head.Y_Size);

  FreeMem(Buffer, Head.X_Size * Head.Y_Size);

 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure TCreateLib.Close;
 Begin
  System.Close(F);
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure TSprite.GotoXY;
 Begin
  If (X > Screen_Width) or (Y > Screen_height) Or (Y < -Head.Y_Size+4) Or (X < -Head.X_Size+4) Then Begin
   Show := False;
  End Else Begin
   Show := True;
   XPos := X;
   YPos := Y;
   Width  := XPos + Head.X_Size;
   Height := YPos + Head.Y_Size-1;
   IF Ypos < 0 Then YSch2 := -Ypos Else YSch2 := 0;
   IF Xpos < 0 Then XSch2 := -Xpos Else XSch2 := 0;
   IF (YPos+Head.Y_Size) > (Screen_Height-1) Then YSch := (YPos+Head.Y_Size)-(Screen_Height-1) Else YSch := 0;
   IF (XPos+Head.X_Size) > (Screen_Width) Then XSch := (XPos+Head.X_Size)-(Screen_Width) Else XSch := 0;
  End;
  Y1 := YPos + YSch2;
  Y2 := Height-YSch;
  X1 := XPos + XSch2;
  X2 := WIDTH - 1 - XSch;
 End;

 Procedure TSprite.Draw;
 Var Frame   : Byte;
     XTeller : Word;
     Calc    : Byte;
     YTeller : Word;
     BufPos  : Word;
     Color   : byte;
     C       : Word;
     Segment : Word;
 Begin

  BufPos := ((Head.Y_Size) * Xsch2);

  If Not Show Then Exit;

  For XTeller := X1 To X2 Do Begin
    Asm
     MOV CX, XTELLER
     AND CL, 3
     MOV AL, 1
     SHL AL, CL
     MOV DX, $03C5;
     OUT DX, AL
{     ADD BUFPOS, YSCH2}
    End;
    Inc(BufPos, YSch2);
    Segment := (XTELLER SHR 2) + PAGE;
    For YTeller := Y1 To Y2 Do Begin
      Color := Cell[Current]^[BufPos]; Asm Inc BufPos End;
      IF Color <> 0 Then Mem[$A000:Segment+YOfs[YTeller]] := Color;
    End; Inc(BufPos, YSch);
  End;
 End;

 Procedure SelectFrame(B : Byte); Assembler;
 Asm
   MOV CL, B
   AND CL, 3
   MOV AL, 1
   SHL AL, CL
   MOV DX, $03C5;
   OUT DX, AL
 End;

 Procedure TSprite.DrawSolid;
 Var Frame   : Byte;
     XTeller : Word;
     Calc    : Byte;
     YTeller : Word;
     BufPos  : Word;
     Color   : byte;
     C       : Word;
     Segment : Word;
 Begin

  If Not Show Then Exit;
  Y1 := YPos + YSch2;
  Y2 := Height-YSch;
  X1 := XPos + XSch2;
  X2 := WIDTH - 1 - XSch;
  BufPos := ((Head.Y_Size) * Xsch2);
  For XTeller := X1 To X2 Do Begin
    Calc := 1 SHL (XTELLER AND 3);
    Asm
     MOV DX, $03C5;
     MOV AL, CALC;
     OUT DX, AL
    End;
    Inc(BufPos, YSch2);
    Segment := (XTELLER SHR 2) + PAGE;
    For YTeller := Y1 To Y2 Do Begin
      Color := Cell[Current]^[BufPos]; Asm Inc BufPos End;
      Mem[$A000:Segment+YOfs[YTeller]] := Color;
    End;
    Inc(BufPos, YSch);
  End;

 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure TSprite.Load;
 Var F        : File;
     NotKlaar : Boolean;
     Result   : Word;
     Index    : Byte;
     Count    : Word;
 Begin
  {$I-}
   Assign(F, FileName);
   Reset(F,1);
  {$I+}
  If IoResult <> 0 Then Exit;
  Seek(F,0); NotKlaar := True; Count := 0;
 While NotKlaar Do Begin
   BlockRead(F, Head, Sizeof(Head), Result);
   If Result < SizeOf(Head) Then Begin Close(F); Exit; End;
     With Head Do Begin
       Inc(Count);
       If Count < Sprite Then Seek(F, FilePos(F)+(X_Size*Y_Size*Cells)) Else Begin
          For Index := 1 To Cells Do Begin
           GetMem(Cell[Index], X_Size * Y_Size);
           BlockRead(F, Cell[Index]^,X_Size * Y_Size);
         End;
         Close(F);
         Exit;
       End;
     End;
   End;
 End;



 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Word_Out(Port : Word; Register, Value : Byte); Assembler;
 Asm
  MOV DX, [PORT]
  MOV AL, [REGISTER]
  MOV AH, [VALUE]
  OUT DX, AX
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure VideoMode(Mode : Byte); Assembler;
 Asm
   MOV AL, [Mode]
   XOR AH, AH
   INT 10h
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Fill(Color : Byte);
 Begin
  Word_Out($03C4,$02, $FF);
  Asm
   Mov AX, $A000
   Mov es,Ax; Mov Di, Page; mov cx, MaxSize; mov al,Color; mov ah,al;
   mov bx,ax; db 66h; shl ax,16; mov ax,bx; mov bx,cx; shr cx,2; db 66h;
   rep stosw; and bx,3; mov cx,bx; rep stosb
  end;
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure ModeX(Width, Height : Word);
 Var Index : Word;
 Begin
  VideoMode(MCGA);
  Word_Out($03C4,$04, $06); (* Disable Chain-4 Modus *)
  Fill(0);
  Word_Out($03D4,$14, $00);
  Word_Out($03D4,$17, $E3);

  Screen_Width  := 320;
  Screen_Height := 200;

  If Width = 360 Then Begin
    Word_Out($03D4,$11, $2C);
    Port[$03C2] := $E7;
    Word_Out($03D4,$00, 107);
    Word_Out($03D4,$01, 89);
    Word_Out($03D4,$02, 90);
    Word_Out($03D4,$03, 142);
    Word_Out($03D4,$04, 94);
    Word_Out($03D4,$05, 138);
    Word_Out($03D4,$13, 45);
    Word_Out($03D4,$11, 142);
    Screen_Width := 360;
  End Else Begin
   Port[$03C2] := $E3;
  End;

  If (Height = 240) or (Height = 480) Then Begin
    Word_Out($03D4,$11, $2C);

    Word_Out($03D4,$06, $0D);
    Word_Out($03D4,$07, $3E);
    Word_Out($03D4,$10, $EA);
    Word_Out($03D4,$11, $AC);
    Word_Out($03D4,$12, $DF);
    Word_Out($03D4,$15, $E7);
    Word_Out($03D4,$16, $06);

    Screen_Height := Height;

  End;

  If (Height = 400) or (Height = 480) Then Begin
      Word_Out($03D4, $09, $40);

      Screen_Height := Height;
  End;

  MaxSize := Screen_Height * (Screen_Width Shr 2);
  Screen_Width2 := (Screen_Width Shr 2);

  PageOfs[0] := 0;
  PageOfs[1] := MaxSize;
  PageOfs[2] := MaxSize Shl 1;
{  PageOfs[3] := MaxSize * 3;}
  For Index := 1 To Screen_Height Do YOfs[Index] := Index * (Screen_Width Shr 2);
  Fill(0);

 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Point(X,Y, Col : LongInt);
 Var Calc : Byte;
 Begin
  Calc := 1 SHL (X AND 3);
  Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
  Mem[$A000:YOfs[Y]+(X Shr 2)+Page] := Col;
 End;

 Procedure Box(X1,Y1, X2, Y2 : Word; Color, Control : Byte);
 Var Calc : Byte; TempX, TempY : Word;
 Begin
  If Control = 1 Then Begin
   For TempX := X1 TO X2 Do Begin
     Calc := 1 SHL (TempX AND 3);
     Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
     For TempY := Y1 TO Y2 Do Begin
      Mem[$A000:YOfs[TempY]+(TempX Shr 2)+Page] := Color;
     End;
   End;
  End Else Begin
   For TempX := X1 TO X2 Do Begin
     Calc := 1 SHL (TempX AND 3);
     Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
     Mem[$A000:YOfs[Y1]+(TempX Shr 2)+Page] := Color;
   End;
   For TempX := X1 TO X2 Do Begin
     Calc := 1 SHL (TempX AND 3);
     Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
     Mem[$A000:YOfs[Y2]+(TempX Shr 2)+Page] := Color;
   End;
   Calc := 1 SHL (X1 AND 3);
   Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
   For TempY := Y1 TO Y2 Do Begin
     Mem[$A000:YOfs[TempY]+(X1 Shr 2)+Page] := Color;
    End;
   Calc := 1 SHL (X2 AND 3);
   Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
   For TempY := Y1 TO Y2 Do Begin
     Mem[$A000:YOfs[TempY]+(X2 Shr 2)+Page] := Color;
   End;
  {   For TempY := Y1 TO Y2 Do Begin
      Mem[$A000:YOfs[TempY]+(TempX Shr 2)+Page] := Color;
     End;}
  End;
 End;

 (*///////s/////////////////////////////////////////////////////////////////*)

 Procedure VideoTop(S : Word); Assembler;
 asm
   mov dx, 03D4h; mov al, 0Dh; out dx, al;
   mov dx, 03D5h; mov ax, S  ; out dx, al;
   mov dx, 03D4h; mov al, 0Ch; out dx, al;
   mov dx, 03D5h; mov al, ah ; out dx, al;
  End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure SetDrawPage(P : Byte);
 Begin
  Page := PageOfs[P];
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure SetVisualPage(P : Byte);
 Begin
  VideoTop(PageOfs[P]);
 End;

 (*////////////////////////////////////////////////////////////////////////*)

Const
        Rom_Char_Set_Seg    = $F000;
        Rom_Char_Set_Off    = $FA6E;
        Char_Height         = 8;
        Char_Width          = 8;

 Procedure Blit_Char(XC,YC : Word;Const C : Char; Color : Byte; Trans_Flag : Boolean);
 Var X,y : Word;
     Work_Char : Word;
     Bit_mask : Byte;
 Begin

  For Y := 0 To Char_Height-1 Do Begin

  Work_char := Mem[Rom_Char_Set_Seg:Rom_char_Set_Off + (Ord(C) * Char_Height) + Y];

    Bit_Mask := $0080;

    For X := 0 To Char_Width-1 Do Begin

      If (Work_Char And Bit_Mask) = Bit_Mask Then Point(Xc+X,Yc, Color) Else
      if Not Trans_Flag Then Point(Xc+X,Yc, 0);
      Bit_Mask := Bit_Mask Shr 1;
    End;
      Inc(Yc);
  End;
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Blit_String(X, Y : Word;Const Text : String; Color : Byte; Trans_Flag : Boolean);
 Var Index : Byte;
 Begin
  For Index := 1 To Length(Text) Do Begin
   Blit_Char(X+(Index Shl 3), Y, Text[Index], Color, Trans_Flag);
  End;
 End;

 (*////////////////////////////////////////////////////////////////////////*)

 Procedure Blit_String_Shadow(X, Y : Word; Text : String; Var Buffer : TBuffer);
 Var Index : Byte;
 Begin
  For Index := 1 To Length(Text) Do Begin
   Blit_Char(X+(Index Shl 3)+1, Y+1, Text[Index], 8, True);
   Blit_Char(X+(Index Shl 3), Y, Text[Index], 15, True);
  End;
 End;

Begin
 Page := 0;
End.